// server definition and activation ********************
var port = 1337;
var server = require('http').createServer().listen(port);
console.log(getTime() + ' Server running at 127.0.0.1:' + port);
// end server definition and activation ****************
// global variables ************************************
global.__basedir = __dirname;
var spawn = require('child_process').spawn;
var fs = require('fs');		// handle file system
var path = require("path");
var Regexp = /name=\"(.+)\"\r\n\r\n(.*)\r\n/gm;		// for extract form data
server.on('request', function(request, response) {
    var Url = require('url').parse(request.url,true)
	var pathName = Url['pathname'];
	var inData = '';	//	for POST data recovery (possibly)
	request.on('data', function(chunk) {
		inData += chunk.toString();
	});
    request.on('end', function() {
//		Url = require('url').parse(request.url,true)		
		if (pathName == "/") pathName = "\\index.html";	// first call
		console.log(getTime() + " Request resource: " + pathName)
		fs.access(__basedir + pathName,(err) => {		// check if file exists)
			if (err == null) {
				var type = path.extname(pathName).substring(1).toLowerCase();
				var cType = "text/html; charset=utf-8"
				if (typeof types[type] != "undefined") cType = types[type];
				if (type == "php") {
					var parms = Url['query'];		// data from GET or URI
					// extract fields
					match = Regexp.exec(inData);	// data from form (POST method)
					while (match != null) {			// matched text: match[0]; capturing group n: match[n]
						parms[match[1]] = match[2];
						match = Regexp.exec(inData);
					}
					var requests = "include '" + __basedir + pathName + "';";
					// prepare fields for PHP
					for(q in parms) requests = "\$_REQUEST['" + q +"'] = '" + parms[q] + "';" + requests;
					var spawnPHP = spawn('php',["-r",requests]);
					spawnPHP.stdout.on('data',function (data) {
							response.writeHead(200, {'Content-Type': cType});
							response.end(data);
							console.log(getTime() + " Sent resource: " + pathName)
						});
				} else {
 					fs.readFile(__basedir + pathName, (err,data) => {
						if (err) throw err;
						response.writeHead(200, {'Content-Type': cType});
						response.end(data,'binary');
						console.log(getTime() + " Sent resource: " + pathName)
					});
				}				
			} else {
				response.writeHead(404, {'Content-Type': 'text/html; charset=utf-8'});
				response.end("<img src='images/condor.gif'>" + err.message);
				console.log(err.message);
			}
		}
		);		
    });
});
function getTime() {	
	var date = new Date();
	return date.toLocaleTimeString();
}
// mime type list at: https://github.com/creationix/simple-mime/blob/master/simple-mime.js

types = {
  avi: "video/x-msvideo",
  bin: "application/octet-stream",
  bmp: "image/bmp",
  css: "text/css",
  csv: "text/csv",
  doc: "application/msword",
  dot: "application/msword",
  eps: "application/postscript",
  gif: "image/gif",
  gz: "application/x-gzip",
  htm: "text/html",
  html: "text/html",
  ico: "image/vnd.microsoft.icon",
  jpeg: "image/jpeg",
  jpg: "image/jpeg",
  js: "application/javascript",
  json: "application/json",
  log: "text/plain",
  m4v: "video/mp4",
  mid: "audio/midi",
  midi: "audio/midi",
  mp3: "audio/mpeg",
  mp4: "video/mp4",
  mp4v: "video/mp4",
  mpeg: "video/mpeg",
  mpg: "video/mpeg",
  pdf: "application/pdf",
//  php: "text/plain",
  php: "text/html",
  png: "image/png",
  pps: "application/vnd.ms-powerpoint",
  ppt: "application/vnd.ms-powerpoint",
  ps: "application/postscript",
  text: "text/plain",
  tif: "image/tiff",
  tiff: "image/tiff",
  txt: "text/plain",
  wma: "audio/x-ms-wma",
  wav: "audio/x-wav",
  wrl: "model/vrml",
  xls: "application/vnd.ms-excel",
  xml: "application/xml",
  zip: "application/zip"
};